.386
.MODEL FLAT

.CODE
_run:

include         stdparas.inc                            ; PA1-PA4
include         abpstruc.inc                            ; asmBmpPara-structure


; *********************************************************************************************

asmBmpPara      EQU     <PA1>
rgb             EQU     <PA2>                           ; RGB-value to be added
flg             EQU     <PA3>                           ; overlap yes/no

; *********************************************************************************************

changeRGB       PROC    NEAR

init:           mac     SAVE
                mov     ebx,asmBmpPara
                mov     esi,srcBits
                mov     edi,tgtBits
                mov     ecx,tgtHeight
                imul    ecx,tgtWidth

                cmp     flg,1
                sbb     bh,bh

bmp_loop:       mov     edx,rgb
bmp_loop_1:     lodsb
                add     al,dl
                sbb     bl,bl
                and     bl,bh
                or      al,bl
                ror     edx,8
                ror     eax,8
                test    esi,3
                jpo     bmp_loop_1

                inc     esi
                shr     eax,8
                stosd
                dec     ecx
                jnz     bmp_loop                

                stc
finish:         mac     REST

changeRGB       ENDP

END _run
