Attribute VB_Name = "asm_ChangeRGB"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

' asmChangeRGB
'
' CALL          asmChangeRGB(ptr:lpAsmBmpPara, [r:redfct], [g:greenfct], [b:bluefct],
'     [flg])
'
' IN:           lng:ptr Points to asmBmpPara-structure
'               lng:R   value to be added to red
'               lng:G   value to be added to green
'               lng:B   value to be added to blue
'               log:flg .T.: ignore boundaries (default)
'                       .F.: take care of boundaries (>255 => 255)
'
' OUT:          bol     success
'
Function asmChangeRGB(lpAsmBmpPara As Long, Optional R As Long, Optional G _
    As Long, Optional B As Long, Optional flg As Boolean = True) As Boolean

    
    Static asm(18) As Long
    
    If asm(0) = 0 Then
        asm(0) = &HEC8B5590
        asm(1) = &H8B575653
        asm(2) = &H738B085D
        asm(3) = &H2C7B8B14
        asm(4) = &HF204B8B
        asm(5) = &H831C4BAF
        asm(6) = &H1A01107D
        asm(7) = &HC558BFF
        asm(8) = &H1AC202AC
        asm(9) = &HADF22DB
        asm(10) = &H8CAC1C3
        asm(11) = &HF708C8C1
        asm(12) = &H3C6
        asm(13) = &H46E97B00
        asm(14) = &HAB08E8C1
        asm(15) = &HF9DE7549
        asm(16) = &H5E5FC01B
        asm(17) = &H10C25D5B
        asm(18) = &H0
    End If
    
    ' ************************************************************
            
    asmChangeRGB = CallWindowProc(asm(0), lpAsmBmpPara, RGB(B, G, R), flg, 0)
    
End Function

' basChangeRGB
'
' AUFRUF:       basChgRGB([R], [G], [B], [F1])
'
' EIN:          lng:R   zu addierender Rot-Wert
'               lng:G   zu addierender Grn-Wert
'               lng:B   zu addierender Balu-Wert
'               log:F1  .T.: berlappend (Vorgabe)
'                       .F.: nicht berlappend (>255 => 255)
'
' AUS:          log     Erfolg
'
Function basChangeRGB(src() As Byte, tgt() As Byte, Optional R As Long, Optional _
    G As Long, Optional B As Long, Optional F1 As Boolean = True) As Boolean
    
    Dim X1      As Long
    Dim Y1      As Long
    Dim N1      As Long
    Dim N2      As Long
    
    N1 = Not F1
    
    For X1 = 1 To UBound(src, 1) Step 4
        For Y1 = 1 To UBound(src, 2)
            N2 = src(X1 + 0, Y1) + B
            If N2 > 255 Then N2 = (N2 Or N1) And 255
            tgt(X1 + 0, Y1) = N2
            
            N2 = src(X1 + 1, Y1) + G
            If N2 > 255 Then N2 = (N2 Or N1) And 255
            tgt(X1 + 1, Y1) = N2
            
            N2 = src(X1 + 2, Y1) + R
            If N2 > 255 Then N2 = (N2 Or N1) And 255
            tgt(X1 + 2, Y1) = N2
        Next
    Next
    
    basChangeRGB = True
End Function
