VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frm_ChangeRGB 
   Caption         =   "Form1"
   ClientHeight    =   4410
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4395
   LinkTopic       =   "Form1"
   ScaleHeight     =   4410
   ScaleWidth      =   4395
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command3 
      Caption         =   "Command3"
      Height          =   255
      Left            =   3360
      TabIndex        =   6
      Top             =   3360
      Width           =   735
   End
   Begin VB.CheckBox Check1 
      Caption         =   "Check1"
      Height          =   255
      Left            =   2040
      TabIndex        =   5
      Top             =   3840
      Width           =   735
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   3000
      TabIndex        =   4
      Text            =   "Combo1"
      Top             =   2760
      Width           =   975
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Command2"
      Height          =   375
      Left            =   1680
      TabIndex        =   3
      Top             =   3240
      Width           =   1455
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   315
      Left            =   240
      TabIndex        =   2
      Top             =   3240
      Width           =   1215
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   255
      Left            =   240
      TabIndex        =   1
      Top             =   2760
      Width           =   1695
   End
   Begin VB.PictureBox Picture1 
      Height          =   2055
      Left            =   120
      ScaleHeight     =   1995
      ScaleWidth      =   2835
      TabIndex        =   0
      Top             =   120
      Width           =   2895
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   3360
      Top             =   1080
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
End
Attribute VB_Name = "frm_ChangeRGB"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!


'---------------------------------------------------------------------------------------
' (softKUS) - VIII/2003
'---------------------------------------------------------------------------------------
' Die Funktion "ChangeRGB" ndert die RGB-(Rot/Grn/Blau)-Anteile.
'
' Fr die Umsetzung wird eine Assembler-(Maschinensprache)-Routine benutzt,
' deren Funktionsweise nicht ohne weiteres ersichtlich ist. Deshalb ist eine
' Basic-Funktion, basChangeRGB, angefgt. Per Mausklick auf Command3 kann
' zwischen Basic- und Assemblerbenutzung hin- und hergeschaltet werden.
'
' Das Beispiel besteht aus drei Modulen:
' 1. Form1    - Dient blo zur Demonstration
' 2. Module1  - Enthlt grundlegendes zum Lesen/Schreiben der Bilder
' 3. Module2  - Enthlt die eigentliche Bildbearbeitung (asmChangeRGB/basChangeRGB)
'
' Die ASM-Routine, asmChangeRGB, kann auch vllig losgelst vom hiesigen Rahmen
' benutzt werden. Es mu lediglich gewhrleistet sein, da der erste Parameter
' (lpAsmBmpPara) auf eine genau nach unten beschriebenem Muster erstellte und
' mit gltigen Werten initialisierte Struktur verweist - andernfalls kommt
'     es
' garantiert zum PC-Absturz.
'
'---------------------------------------------------------------------------------------
'
' Ein Formular mit:
' Picture1, Command1 bis Command3, HScroll1, CommonDialog1, Combo1, Check1
'
'---------------------------------------------------------------------------------------

Option Explicit
Option Base 0


' *
' **
' *** Konstanten
' *** - fr die Bildbearbeitung sind nur die Parameter fr die Bildlaufleiste
' ***   interessant (HPar): Min;Max;(Standard-)Value;SmallChange;LargeChange
' **
' *

' grerer Wert => grere Form
Private Const XYcm      As Long = 567
Private Const Ftxt      As String = "asm-Beispiel ChangeRGB"
Private Const HPar      As String = "00000;00255;00000;00001;00010"


' *
' **
' *** Variablen
' **
' *

' log: Bildlaufleiste aktiv J/N
Dim scrH_flg            As Boolean

' lng: Bildlaufleisten-Standardwert
Dim scrH_std            As Long

' udt: Datenstruktur fr ASM-Routine
Dim abp                 As asmBmpPara

' bin: Bilddaten
Dim src()               As Byte

' bin: Puffer fr die Bildbearbeitung
Dim tgt()               As Byte

' log: .T.=Assember, .F.=Basic
Dim pmd                 As Boolean

Private Sub Form_Load()
    
    ' Initialisieren der Byte-Arrays
    ReDim src(1, 1)
    
    ' (vermeidet Zugriffsfehler)
    ReDim tgt(1, 1)
    
    With Me
        .ScaleMode = vbTwips
        .Width = (Me.Controls.Count * 2 - 2) * XYcm
        .Height = (Me.Controls.Count * 2 - 2) * XYcm
        .Caption = Ftxt
    End With
    
    With HScroll1
        .Min = Val(Mid$(HPar, 1, 5))
        .Max = Val(Mid$(HPar, 7, 5))
        .Value = Val(Mid$(HPar, 13, 5))
        .SmallChange = Val(Mid$(HPar, 19, 5))
        .LargeChange = Val(Mid$(HPar, 25, 5))
        scrH_std = .Value
    End With
    
    With Combo1
        .AddItem "Rot"
        .AddItem "Grn"
        .AddItem "Blau"
        .ListIndex = 0
    End With
    
    With Check1
        .Caption = "Overlap"
        .Value = 1
    End With
    
    Command1.Caption = "Bild laden"
    Command2.Caption = "Undo"
    Command3.Caption = "Basic"
    Picture1.ScaleMode = vbTwips
    
    pmd = True
End Sub

' dummy Bild erzeugen
Private Sub Form_Initialize()
    Dim X1 As Long
    
    Randomize Timer
    Picture1.AutoRedraw = True
    
    For X1 = 1 To 400
        Picture1.DrawWidth = 1 + Rnd() * 30
        Picture1.Line (Rnd * Picture1.Width, Rnd * Picture1.Height)-(Rnd * Picture1.Width, _
            Rnd * Picture1.Height), RGB(Rnd * 255, Rnd * 255, Rnd * 255)
        
    Next X1
    
    Picture1.AutoRedraw = False
    
    scrH_flg = ReadData(Picture1.Image, abp, src, tgt, pmd, False)
    If scrH_flg Then WriteData Picture1, abp.src, True
End Sub

Private Sub Form_Resize()
    Dim dfw As Long
    Dim dfh As Long
    Dim tmp As Long
    
    dfw = Me.Width - Me.ScaleWidth
    dfh = Me.Height - Me.ScaleHeight
    tmp = ((Me.Controls.Count - 3) * 2.25 + 0.25) * XYcm + dfw
    
    If Me.Width < tmp Then Me.Width = tmp
    If Me.Height < 5 * XYcm Then Me.Height = 5 * XYcm
    
    With Command1
        
        ' Bild laden
        .Top = 0.25 * XYcm
        .Left = 0.25 * XYcm
        .Width = 2 * XYcm
        .Height = 0.5 * XYcm
    End With
    
    With Combo1
        
        ' Mode
        .Top = 0.25 * XYcm
        .Left = 2.5 * XYcm
        .Width = 2 * XYcm
    End With
    
    With Check1
        
        ' Flag
        .Top = 0.25 * XYcm
        .Left = 4.75 * XYcm
        .Width = 2 * XYcm
        .Height = 0.5 * XYcm
    End With
    
    With Command2
        
        ' Undo
        .Top = 0.25 * XYcm
        .Left = Me.Width - 4.5 * XYcm - dfw
        .Width = 2 * XYcm
        .Height = 0.5 * XYcm
    End With
    
    With Command3
        
        ' bas/asm
        .Top = 0.25 * XYcm
        .Left = Me.Width - 2.25 * XYcm - dfw
        .Width = 2 * XYcm
        .Height = 0.5 * XYcm
    End With
    
    
    With Picture1
        .Top = 1 * XYcm
        .Left = 0.25 * XYcm
        .Width = Me.Width - 0.5 * XYcm - dfw
        .Height = Me.Height - 2 * XYcm - dfh
    End With
    
    With HScroll1
        .Top = Picture1.Top + Picture1.Height + 0.25 * XYcm
        .Left = 0.25 * XYcm
        .Width = Picture1.Width
        .Height = 0.5 * XYcm
    End With
End Sub

Private Sub Picture1_DblClick()
    Form_Initialize
End Sub

' Bild laden
Private Sub Command1_Click()
    
    ' obj: enthlt das zu ladende Bild
    Dim pic As IPicture
    
    On Error Resume Next
    
    With CommonDialog1
        .CancelError = True
        .Flags = &H281800
        .Filter = "Bilder |*.bmp;*.jpg||"
        .ShowOpen
        
        If Err = 0 Then
            Set pic = LoadPicture(.FileName)
            
            If pic Is Nothing Then
                MsgBox "Bild konnte nicht geladen werden"
                
            ElseIf ReadData(pic, abp, src, tgt, pmd) Then
                
                ' alles okay => setze pic auf die PictureBox
                Set Picture1.Picture = pic
                
                ' setze HScroll1 auf den Standardwert
                Command2_Click
                scrH_flg = True
            End If
        End If
    End With
    
    Picture1.SetFocus
End Sub

' Undo
Private Sub Command2_Click()
    ' Bildlaufleiste deaktivieren
    scrH_flg = False
    
    ' nderung am Bild zurcknehmen
    WriteData Picture1, abp.src
    
    ' Bildlaufleiste auf Ausgangswert
    HScroll1 = scrH_std
    
    ' Bildlaufleiste aktivieren
    scrH_flg = True
    Picture1.SetFocus
End Sub

' Umschalten zw. bas und asm
Private Sub Command3_Click()
    pmd = Not pmd
    Command3.Caption = Choose(pmd + 2, "Basic", "Assembler")
    
    If pmd = False And Picture1.Picture.Handle <> 0 And VarPtr(tgt(1, 1)) <> abp.tgt.bmBits _
        Then
    
        ' Wenn abp.tgt direkt auf den Speicher der Bitmap
        ' weist, mu fr die Basic-Routine auf ein ByteArray
        ' umgelenkt werden. Dazu kann auch mit einer SAVEARRAY-
        ' Struktur gearbeitet werden - das fhrte hier aber zu weit.
        
        ReDim tgt(1 To UBound(src, 1), 1 To UBound(src, 2))
        abp.tgt.bmBits = VarPtr(tgt(1, 1))
    End If
    
    Picture1.SetFocus
End Sub

Private Sub Check1_Click()
    HScroll1_Change
End Sub

Private Sub Combo1_Click()
    HScroll1_Change
End Sub

Private Sub HScroll1_Scroll()
    HScroll1_Change
End Sub

Private Sub HScroll1_Change()
    Dim B1 As Boolean
    Dim R  As Long
    Dim G  As Long
    Dim B  As Long
    
    If scrH_flg = False Or Picture1.Picture.Handle = 0 Then
        
        ' deaktiviert/kein Bild geladen => ignorieren
        
    Else
        Select Case Combo1.ListIndex
        Case 0
            R = HScroll1
        Case 1
            G = HScroll1
        Case 2
            B = HScroll1
        End Select
        
        If pmd Then
            B1 = asmChangeRGB(VarPtr(abp), R, G, B, Check1.Value)
            
        Else
            B1 = basChangeRGB(src, tgt, R, G, B, Check1.Value)
        End If
        
        ' gendertes Bild ausgeben
        
        If B1 Then WriteData Picture1, abp.tgt
    End If
End Sub
